/* @(#) $Id: HtmlDigitalSigTool.js,v 1.6 2012/12/05 19:02:02 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var gParams = null;

var gTabboxElem;
var gSignTabElem;
var gVerifyTabElem;

var gSignCmdButtonElem;
var gVerifyCmdButtonElem;

var gXmlParser;
var gXmlSerializer;

var /* nsIX509Cert	  */ gCertDB = null;
var /* alrIXPXmlDSigTool  */ gXmlDSigTool = null;
var /* alrIX509CertDBUtil */ gX509CertDBUtil = null;

var alreadyInit = false;

var XPILoadErrorMessage = "Make sure that DLLs (shared libraries) from Apache Xerces-C++ and Xalan-C++ are in your PATH (LD_LIBRARY_PATH) environment variable.";

function xmldsigffext_htmldsig_initOnLoad()
{
    dump("xmldsigffext_htmldsig_initOnLoad():................Start.\n");

    if (alreadyInit) {
    	return;
    }
    alreadyInit = true;

    xmldsigffext_isSupportedOS();

    try {
    	gCertDB = Components.classes["@mozilla.org/security/x509certdb;1"].
			getService(Components.interfaces.nsIX509CertDB);
    	gXmlDSigTool = Components.classes["@avaya.com/pkm/xmldsigtool;1"].
    			getService(Components.interfaces.alrIXPXmlDSigTool);
	gX509CertDBUtil = Components.classes["@avaya.com/pkm/x509certdbutil;1"].
    			getService(Components.interfaces.alrIX509CertDBUtil);
    } catch (ex) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool - ex: " + ex + "\n");
	dump(XPILoadErrorMessage + "\n");
	throw ex;
    }
    if (gXmlDSigTool == null) {
    	alert("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
    	dump("xmldsigffext_initSignFormXULElems(): failed to create instance of alrIXPXmlDSigTool.\n");
	dump(XPILoadErrorMessage + "\n");
    	return;
    }

    gXmlParser = new DOMParser();
    gXmlSerializer = new XMLSerializer();

    gSignCmdButtonElem = document.getElementById('xmldsigffext.htmldsig.cmd.sign');
    gVerifyCmdButtonElem = document.getElementById('xmldsigffext.htmldsig.cmd.verify');

    try {
    	xmldsigffext_htmldsig_initFormXULElems();

	xmldsigffext_htmldsig_showSignForm();
	// xmldsigffext_htmldsig_showVerifyForm();

    } catch (ex) {
    	dump("xmldsigffext_initOnLoad(): ex - " + ex + "\n");
    }

    xmldsigffext_htmldsig_initParamsOnLoad();

    /**********************************************/
    /* TODO:  TEST CODE - remove after test phase */
    /**********************************************/
    var testMode = avxmldsig.dsigtool.PrefUtil.getPreference("extensions.avxmldsig.test", false);
    if (testMode) {
    try {
        var tokenPassword = "abcd1234";
        var tokendb = Components.classes["@mozilla.org/security/pk11tokendb;1"].
                            getService(Components.interfaces.nsIPK11TokenDB);
        var token = tokendb.getInternalKeyToken();
        if (token) {
            token.checkPassword(tokenPassword);
            token.login(false);
        }
    } catch (ex) {}
    }

    dump("xmldsigffext_htmldsig_initOnLoad():................End.\n");
}


function xmldsigffext_htmldsig_initParamsOnLoad()
{
    // dump("xmldsigffext_htmldsig_initParamsOnLoad():................Start.\n");

    if ((window.arguments == null) || (window.arguments.length == 0)) {

    	// gXmlDSigInputFilePickerElem.filepath = "/tmp/XMLDSigTool/XXXXXXX.xml";
    	// xmldsigffext_htmldsig_xmlDocFileChangeHandler();

    	return false;
    }

    gParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    var paramCnt = gParams.GetInt(0);
    if (paramCnt <= 0) {
    	return false;
    }
    var unsignedHTMLFilePath = gParams.GetString(0);
    var signedXMLFilePath = gParams.GetString(1);

    dump("unsignedHTMLFilePath: " + unsignedHTMLFilePath + " " + 
    		"signedXMLFilePath: " + signedXMLFilePath + " " + 
		"\n");

    xmldsigffext_htmldsig_doOnloadInitSignParam(unsignedHTMLFilePath, signedXMLFilePath);

    // dump("xmldsigffext_htmldsig_initParamsOnLoad():................End.\n");
    return true;
}

function xmldsigffext_htmldsig_showSignForm()
{
    dump("xmldsigffext_htmldsig_showSignForm():................Start.\n");

    gSignCmdButtonElem.hidden = false;
    gVerifyCmdButtonElem.hidden = true;

    dump("xmldsigffext_htmldsig_showSignForm():................End.\n");
}

function xmldsigffext_htmldsig_showVerifyForm()
{
    // dump("xmldsigffext_htmldsig_showVerifyForm():................Start.\n");

    gSignCmdButtonElem.hidden = true;
    gVerifyCmdButtonElem.hidden = false;

    // dump("xmldsigffext_htmldsig_showVerifyForm():................End.\n");
}

function xmldsigffext_enableForVerify()
{
    xmldsigffext_htmldsig_showVerifyForm();
}


function xmldsigffext_enableForSign()
{
    xmldsigffext_htmldsig_showSignForm();
}

function xmldsigffext_enableForResign()
{
    xmldsigffext_htmldsig_showSignForm();
}

function xmldsigffext_htmldsig_cmdVerify()
{
    dump("xmldsigffext_htmldsig_cmdVerify():..................Start.\n");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }

    var isPassed = false;
    try {
    	isPassed = xmldsigffext_verifySignedHTMLDoc();
    } catch (ex) {
    	dump("xmldsigffext_htmldsig_cmdVerify(): xmldsigffext_verifySignedHTMLDoc() failed to verify signed XML file - ex : " + ex + "\n");
	return;
    }
    if (isPassed) {
    	alert("xmldsigffext_htmldsig_cmdVerify(): successfully verified the signed XML.\n");
    }
    else {
    	alert("xmldsigffext_htmldsig_cmdVerify(): failed to verify the signed XML.\n");
    }

    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    dump("xmldsigffext_htmldsig_cmdVerify():..................End.\n");
}

function xmldsigffext_htmldsig_cmdSign()
{
    dump("xmldsigffext_htmldsig_cmdSign():..................Start.\n");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }

    var signedFile = null;
    try {
    	signedFile = xmldsigffext_signHTMLDocToFile();
    } catch (ex) {
    	dump("xmldsigffext_htmldsig_cmdSign(): failed to create signed XML file - ex : " + ex + "\n");
    	alert("xmldsigffext_htmldsig_cmdSign(): failed to create signed XML file - ex : " + ex + "\n");
	return;
    }
    if (!signedFile) {
    	dump("xmldsigffext_htmldsig_cmdSign(): failed to create signed XML file\n");
    	alert("xmldsigffext_htmldsig_cmdSign(): failed to create signed XML file\n");
	return;
    }
    alert("xmldsigffext_htmldsig_cmdSign(): Successfully created the signed XML.\n");
    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    dump("xmldsigffext_htmldsig_cmdSign():..................End.\n");
}

function xmldsigffext_htmldsig_cmdClose()
{
    dump("xmldsigffext_htmldsig_cmdClose():..................Start.\n");
    window.close();
}

function xmldsigffext_htmldsig_cmdCancel()
{
    dump("xmldsigffext_htmldsig_cmdCancel():..................Start.\n");
    if (gParams) {
        gParams.SetInt(0, 0);
    }
    window.close();
}

