<?xml version="1.0" encoding="ISO-8859-1"?>

<!-- @(#) $Id: html2xhtml.xsl,v 1.1 2009/01/05 06:04:14 subrata Exp $ -->

<!-- ***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is Avaya Labs Research, Avaya Inc. Code.
   -
   - The Initial Developer of the Original Code is
   -     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
   - Portions created by the Initial Developer are Copyright (C) 2007.
   - the Initial Developer. All Rights Reserved.
   -
   - Contributor(s):
   -   Subrata Mazumdar (mazum@avaya.com)
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK ***** -->



<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
    >
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" />

<xsl:param name="srcXmlDocNSURI" select="''"/>
<xsl:param name="targetXmlDocNSURI" select="'http://www.w3.org/1999/xhtml'"/>
<xsl:param name="targetXmlDocRootTag" select="'html'"/>


<xsl:template match="/">
    <xsl:element name="{$targetXmlDocRootTag}" namespace="{$targetXmlDocNSURI}">
	<xsl:apply-templates select="."/>
    </xsl:element>
</xsl:template>

<xsl:template match="*[namespace-uri()=$srcXmlDocNSURI]">
    <xsl:variable name="elemNsUri" select="namespace-uri()"/>
    <xsl:variable name="elemTagName" select="name()"/>
    <xsl:variable name="elemLocalName" select="local-name()"/>
    <xsl:variable name="elemClassNames" select="'xul'"/>

    <xsl:element name="{$elemLocalName}" namespace="{$targetXmlDocNSURI}">
	<xsl:apply-templates select="@*"/>
	<!--
	<xsl:attribute name="class"><xsl:value-of select="$elemClassNames"/></xsl:attribute>
	<xsl:attribute name="origtagname"><xsl:value-of select="$elemTagName"/></xsl:attribute>
	<xsl:attribute name="orignsuri"><xsl:value-of select="$elemNsUri"/></xsl:attribute>
	<xsl:choose>
	    <xsl:when test="$elemLocalName='Object'">
		<xsl:for-each select="node()">
		    <xsl:choose>
			<xsl:when test="namespace-uri()=$srcXmlDocNSURI">
			    <xsl:apply-templates select="."/>
			</xsl:when>
			<xsl:otherwise>
			    <xsl:call-template name="clone-node-template"/>
			</xsl:otherwise>
		    </xsl:choose>
		</xsl:for-each>
	    </xsl:when>
	    <xsl:otherwise>
	    </xsl:otherwise>
	</xsl:choose>
	-->
		<xsl:apply-templates select="node()"/>
    </xsl:element>
</xsl:template>

<xsl:template match="*[namespace-uri()!=$srcXmlDocNSURI]">
  <xsl:call-template name="clone-node-template"/>
  <!--
  <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
  -->
</xsl:template>

<!--
  Copy all the attributes of a node as is.
-->
<xsl:template match="@*">
  <xsl:copy>
  </xsl:copy>
</xsl:template>
<!--
-->

<xsl:template name="attr-copy-template">
 <xsl:for-each select="@*">
   <xsl:copy/>
 </xsl:for-each>
</xsl:template>

<!--
Copy this node and all its children (inclduing all the attributes of node) as is.
-->
<!--
<xsl:template match="@*|node()">
  <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
  <xsl:text>
  </xsl:text>
</xsl:template>
-->

<xsl:template name="clone-node-template">
    <xsl:copy>
	<xsl:apply-templates select="@*"/>
	<xsl:for-each select="node()">
	    <xsl:call-template name="clone-node-template"/>
	</xsl:for-each>
    </xsl:copy>
</xsl:template>


</xsl:stylesheet>

