/* @(#) $Id: SamlSelfTokenCreateWorkFlowInit.js,v 1.10 2012/10/03 23:08:09 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gSamlTokenCreateWorkFlowWizardInitDone = false;
var gSamlTokenCreateWorkFlowWizardElem;
var gSamlTokenSaveInFileElem;

var gButtonNextOrigLabel;
/*
*/



function SamlSelfTokenCreateWorkFlowInit_initOnLoad(aWizardElem)
{
    if (gSamlTokenCreateWorkFlowWizardInitDone) {
    	return;
    }

    XmlDSigToolFormUtil.logTrace("SamlSelfTokenCreateWorkFlowInit_initOnLoad():................Start.\n");
    gSamlTokenCreateWorkFlowWizardInitDone = true;


    gSamlTokenCreateWorkFlowWizardElem = aWizardElem;

    var wizardButtonNextElem = gSamlTokenCreateWorkFlowWizardElem.getButton("next");
    gButtonNextOrigLabel = wizardButtonNextElem.label;

    gSamlTokenSaveInFileElem = document.getElementById("samltoken.form.create.workflow.save");

    XmlDSigToolFormUtil.logTrace("SamlSelfTokenCreateWorkFlowInit_initOnLoad():................End.\n");
}

function SamlSelfTokenCreateWorkFlowInit_doOnloadInitSamlParamX(
	/* String */ aWizardCommandSteps,
	/* String */ aOutXmlFilePath
	)
{
    /*   DEPRECATED */

    /*
    XmlDSigToolFormUtil.logTrace("SamlSelfTokenCreateWorkFlowInit_doOnloadInitSamlParam():................Start.\n");

    // gSamlTokenCreateWorkFlowWizardElem.saveInFile = gSamlTokenSaveInFileElem.checked;
    handleSaveWizardPageOutputChange(gSamlTokenSaveInFileElem);

    if (aWizardCommandSteps) {
    	activateCustomWizardPages(aWizardCommandSteps);
    }

    if (aOutXmlFilePath && (aOutXmlFilePath != "")) {
	gXmlDocWizardElem.outXmlFilePath = aOutXmlFilePath;
    	var finalOutXmlFilePickerRowElem = document.getElementById("samltoken.form.create.workflow.out.file.row");
	// finalOutXmlFilePickerRowElem.hidden = true;
    	var finalOutXmlFilePickerElem = document.getElementById("samltoken.form.create.workflow.out.filepicker");
	finalOutXmlFilePickerElem.filepath = aOutXmlFilePath;
	if (finalOutXmlFilePickerElem.file) {
	    finalOutXmlFilePickerElem.disabled = true;
	}
    }

    XmlDSigToolFormUtil.logTrace("SamlSelfTokenCreateWorkFlowInit_doOnloadInitSamlParam():................End.\n");
    */
}

function xmlDocWorkFlowInitPageShow(aWizardPageElem) 
{
    XmlDSigToolFormUtil.logTrace("xmlDocWorkFlowInitPageShow():................Start.\n");


    var wizardElem = aWizardPageElem.parentNode;
    SamlSelfTokenCreateWorkFlowInit_initOnLoad(wizardElem);

    wizardElem.canAdvance = false;

    var wizardButtonNextElem = gSamlTokenCreateWorkFlowWizardElem.getButton("next");
    wizardButtonNextElem.label = gButtonNextOrigLabel;

    XmlDSigToolFormUtil.logTrace("xmlDocWorkFlowInitPageShow():................30.\n");

    var xmlDocWorkFlowGroupElem = document.getElementById("samltoken.form.create.workflow.group");
    if (xmlDocWorkFlowGroupElem.selectedIndex < 0) {
    	xmlDocWorkFlowGroupElem.selectedIndex = 0;
    }
    handleXmlDocWorkFlowSeqChange(xmlDocWorkFlowGroupElem);

    var samlAssertionTypeMenuElem = document.getElementById("samltoken.form.create.workflow.assertion.type.menu");
    handleSamlAssertionTypeMenuChange(samlAssertionTypeMenuElem);

    wizardElem.canAdvance = true;

    XmlDSigToolFormUtil.logTrace("xmlDocWorkFlowInitPageShow():................End.\n");
}

function updateWizardPageWorkFlowSequence() 
{
    // XmlDSigToolFormUtil.logTrace("updateWizardPageWorkFlowSequence():................Start.\n");

    var startingPageId = null;
    var prevPageId = null;
    var lastPageElem = null;

    var xmlDocWorkFlowStepsRowElem = document.getElementById("samltoken.form.create.workflow.steps.row");
    var xmlDocWorkFlowStepsElems = xmlDocWorkFlowStepsRowElem.getElementsByTagName("checkbox");

    if (xmlDocWorkFlowStepsElems.length > 0) {
    	var xmlDocWorkFlowFinishElem = document.getElementById("samltoken.form.create.workflow.steps.finish");
	xmlDocWorkFlowFinishElem.checked = true;
	xmlDocWorkFlowFinishElem.disabled = true;
    }

    var totStepCnt = 0;
    var generateOutFile = false;
    for (var i = 0; i < xmlDocWorkFlowStepsElems.length; i++) {
    	var xmlDocWorkFlowStepElem = xmlDocWorkFlowStepsElems.item(i);
	if (!xmlDocWorkFlowStepElem.checked) {
	    continue;
	}
	var cmdPageStartId = xmlDocWorkFlowStepElem.getAttribute("cmdPageId");
	if (!cmdPageStartId) {
	    continue;
	}
	var cmdPageEndId = xmlDocWorkFlowStepElem.getAttribute("cmdPageEndId");
	if (!cmdPageEndId) {
	    cmdPageEndId = cmdPageStartId;
	}
    	// XmlDSigToolFormUtil.logDebug("updateWizardPageWorkFlowSequence(): cmdPageStartId: " + cmdPageStartId + " cmdPageEndId: " + cmdPageEndId + "\n");
	if (prevPageId) {
    	    var prevPageElem = gSamlTokenCreateWorkFlowWizardElem.getPageById(prevPageId);
	    if (prevPageElem) {
	    	prevPageElem.next = cmdPageStartId;
    	    	// XmlDSigToolFormUtil.logDebug("updateWizardPageWorkFlowSequence(): " + prevPageId + " ==> " + cmdPageStartId + "\n");
	    }
	}

	prevPageId = cmdPageEndId;
	if (!startingPageId) {
	    startingPageId = cmdPageStartId;
	}

	if (xmlDocWorkFlowStepElem.getAttribute("cmdname") == "finish") {
	    continue;
	}

	if (xmlDocWorkFlowStepElem.getAttribute("genoutfile") == "true") {
	    generateOutFile = true;
	}
	totStepCnt++;
    }

    /*
    if (prevPageId) {
    	var lastPageElem = gSamlTokenCreateWorkFlowWizardElem.getPageById(prevPageId);
	if (lastPageElem) {
    	    lastPageElem.next = "samltoken.form.xmldoc.finish";
    	    XmlDSigToolFormUtil.logDebug("updateWizardPageWorkFlowSequence(): " + prevPageId + " ==> " + lastPageElem.next + "\n");
	}
    }
    */

    if (startingPageId) {
    	setStartingWizardPage(startingPageId);
    }

    var finalOutXmlFilePickerRowElem = document.getElementById("samltoken.form.create.workflow.out.file.row");
    var finalOutXmlFilePickerElem = document.getElementById("samltoken.form.create.workflow.out.filepicker");
    var xmlDocSaveInFileRowElem = document.getElementById('samltoken.form.create.workflow.save.row');

    // XmlDSigToolFormUtil.logDebug("updateWizardPageWorkFlowSequence(): generateOutFile: " + generateOutFile + " totStepCnt: " + totStepCnt + "\n");

    gSamlTokenCreateWorkFlowWizardElem.finalOutXmlFilePickerElem = finalOutXmlFilePickerElem;
    gSamlTokenCreateWorkFlowWizardElem.generateOutFile = generateOutFile;

    if (generateOutFile) {
	if (totStepCnt > 1) {
    	xmlDocSaveInFileRowElem.hidden = false;
	}
	else {
    	xmlDocSaveInFileRowElem.hidden = true;
	}

    	finalOutXmlFilePickerRowElem.hidden = false;
    }
    else {
    	xmlDocSaveInFileRowElem.hidden = true;
    	finalOutXmlFilePickerRowElem.hidden = true;
	if (!finalOutXmlFilePickerElem.disabled) {
	    finalOutXmlFilePickerElem.filepath = "";
	}
    }
    if (!finalOutXmlFilePickerElem.disabled) {
    	handleFinalOutXMLFileChange(finalOutXmlFilePickerElem);
    }

    // XmlDSigToolFormUtil.logTrace("updateWizardPageWorkFlowSequence():................End.\n");
    return startingPageId;
}

function activateWizardPages(aWorkFlowPageNameList) 
{
    // XmlDSigToolFormUtil.logTrace("activateWizardPages():................Start.\n");

    var workFlowPageNames = aWorkFlowPageNameList.split(",");
    for (var i = 0; i < workFlowPageNames.length; i++) {
    	var workFlowPageName = workFlowPageNames[i];
	var workFlowPageActiveElemId = "samltoken.form.create.workflow.steps." + workFlowPageName;
    	// XmlDSigToolFormUtil.logDebug("activateWizardPages(): workFlowPageActiveElemId: " + workFlowPageActiveElemId + "\n");
        var workFlowPageActiveElem = document.getElementById(workFlowPageActiveElemId);
	if (!workFlowPageActiveElem) {
	    continue;
	}
	workFlowPageActiveElem.checked = true;
    }

    updateWizardPageWorkFlowSequence();

    // XmlDSigToolFormUtil.logTrace("activateWizardPages():................End.\n");
    return true;
}

function handleXmlDocWorkFlowSeqChange(aXmlDocWorkFlowGroupElem, ev) 
{
    XmlDSigToolFormUtil.logTrace("handleXmlDocWorkFlowSeqChange():................Start.\n");

    var xmlDocWorkFlowItemElem = aXmlDocWorkFlowGroupElem.selectedItem;
    var workFlowItemValue = xmlDocWorkFlowItemElem.value;

    var xmlDocWorkFlowStepsRowElem = document.getElementById("samltoken.form.create.workflow.steps.row");
    var xmlDocWorkFlowStepsElems = xmlDocWorkFlowStepsRowElem.getElementsByTagName("checkbox");
    for (var i = 0; i < xmlDocWorkFlowStepsElems.length; i++) {
    	var xmlDocWorkFlowStepElem = xmlDocWorkFlowStepsElems.item(i);
	xmlDocWorkFlowStepElem.checked = false;
	if (workFlowItemValue == "custom") {
	    xmlDocWorkFlowStepElem.disabled = false;
	}
	else {
	    xmlDocWorkFlowStepElem.disabled = true;
	}
    }
    if (workFlowItemValue != "custom") {
    	activateWizardPages(workFlowItemValue);
    }

    var workFlowCreateStepElem = document.getElementById("samltoken.form.create.workflow.steps.create");
    var assertionTypeMenuElem = document.getElementById("samltoken.form.create.workflow.assertion.type.menu");
    if (workFlowCreateStepElem.checked) {
    	assertionTypeMenuElem.disabled = false;
    }
    else {
    	assertionTypeMenuElem.disabled = true;
    }

    // XmlDSigToolFormUtil.logTrace("handleXmlDocWorkFlowSeqChange():................End.\n");
}

function activateCustomWizardPages(aCustomWorkFlowSeq) 
{
    // XmlDSigToolFormUtil.logTrace("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................Start.\n");

    var workFlowSeqItemElem = null;
    var workFlowSeqGroupElem = document.getElementById("samltoken.form.create.workflow.group");

    if (!aCustomWorkFlowSeq || (aCustomWorkFlowSeq == "")) {
    	// XmlDSigToolFormUtil.logDebug("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................10.\n");
	
	// TODO: Get the default actions from the preference.
    	workFlowSeqItemElem = document.getElementById("samltoken.form.create.workflow.item01");
    	workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
	handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
	return workFlowSeqItemElem;
    }

    var workFlowSeqItemElemList = workFlowSeqGroupElem.getElementsByAttribute("value", aCustomWorkFlowSeq);
    if (workFlowSeqItemElemList && (workFlowSeqItemElemList.length > 0)) {
    	// XmlDSigToolFormUtil.logDebug("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................20.\n");
	// Found an existing workflow seq item - so select that one and then update the workflow page sequence
    	workFlowSeqItemElem = workFlowSeqItemElemList.item(0);
	workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
	handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
	return workFlowSeqItemElem;
    }
    // XmlDSigToolFormUtil.logTrace("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................30.\n");

    workFlowSeqItemElem = document.getElementById("samltoken.form.create.workflow.custom");
    workFlowSeqGroupElem.selectedItem = workFlowSeqItemElem;
    handleXmlDocWorkFlowSeqChange(workFlowSeqGroupElem);
    // XmlDSigToolFormUtil.logTrace("activateCustomWizardPages(" + aCustomWorkFlowSeq + "):................40.\n");

    activateWizardPages(aCustomWorkFlowSeq);

    // XmlDSigToolFormUtil.logTrace("activateCustomWizardPages():................End.\n");
    return workFlowSeqItemElem;
}

function setStartingWizardPage(aStartingPageId) 
{
    // XmlDSigToolFormUtil.logDebug("setStartingWizardPage(): aStartingPageId: " + aStartingPageId + "\n");


    // Make the input file picker for the first step browsable/modifiable element.
    var nextPageElem = gSamlTokenCreateWorkFlowWizardElem.getPageById(aStartingPageId);
    if (!nextPageElem) {
    	XmlDSigToolFormUtil.logTrace("setStartingWizardPage(): couldn't find aStartingPageId: " + aStartingPageId + "\n");
	return;
    }
    gSamlTokenCreateWorkFlowWizardElem.currentPage.next = aStartingPageId;

    var nexPageInputFilePickerElemList = nextPageElem.getElementsByAttribute("fileMode", "open");
    if (nexPageInputFilePickerElemList.length > 0) {
	var nexPageInputFilePickerElem = nexPageInputFilePickerElemList.item(0);
	nexPageInputFilePickerElem.removeAttribute("readonly");
	nexPageInputFilePickerElem.removeAttribute("browsehidden");
    }
}

function handleXmlDocWorkFlowStepsChange(ev) 
{
    // XmlDSigToolFormUtil.logTrace("handleXmlDocWorkFlowStepsChange():................Start.\n");

    var targetElem = ev.targetElem;

    if (ev) {
    	ev.stopPropagation();
    }

    var workFlowCreateStepElem = document.getElementById("samltoken.form.create.workflow.steps.create");
    var assertionTypeMenuElem = document.getElementById("samltoken.form.create.workflow.assertion.type.menu");
    if (workFlowCreateStepElem.checked) {
    	assertionTypeMenuElem.disabled = false;
    }
    else {
    	assertionTypeMenuElem.disabled = true;
    }

    var startingPageId = updateWizardPageWorkFlowSequence();
    if (!startingPageId) {
    	gSamlTokenCreateWorkFlowWizardElem.canAdvance = false;
    	return;
    }

    gSamlTokenCreateWorkFlowWizardElem.canAdvance = true;

    // XmlDSigToolFormUtil.logTrace("handleXmlDocWorkFlowStepsChange():................End.\n");
}

function handleSaveWizardPageOutputChange(aSaveInFileElem, ev) 
{
    gSamlTokenCreateWorkFlowWizardElem.saveInFile = aSaveInFileElem.checked;
}

function handleFinalOutXMLFileChange(aFinalOutXmlFilePickerElem, ev) 
{
    var finalOutXmlFilePath = aFinalOutXmlFilePickerElem.filepath;
    if (aFinalOutXmlFilePickerElem.file) {
    	gSamlTokenCreateWorkFlowWizardElem.outXmlFilePath = aFinalOutXmlFilePickerElem.filepath;
    }
    else {
    	gSamlTokenCreateWorkFlowWizardElem.outXmlFilePath = null;
    }
}

function handleSamlAssertionTypeMenuChange(aAssetionTypeMenuElem, ev) 
{
    gSamlTokenCreateWorkFlowWizardElem.samlAssertionType = aAssetionTypeMenuElem.value;
}


function xmlDocWorkFlowInitPageAdvanced(aWizardPageElem) 
{
    // XmlDSigToolFormUtil.logTrace("xmlDocWorkFlowInitPageAdvanced():................Start.\n");

    gSamlTokenCreateWorkFlowWizardElem.saveInFile = gSamlTokenSaveInFileElem.checked;
    gSamlTokenCreateWorkFlowWizardElem.firstStep = true;


    var nextPageElem = gSamlTokenCreateWorkFlowWizardElem.getPageById(aWizardPageElem.next);

    if (gSamlTokenCreateWorkFlowWizardElem.inXmlFilePath) {
    	nextPageElem.filepath = gSamlTokenCreateWorkFlowWizardElem.inXmlFilePath;
    	// XmlDSigToolFormUtil.logDebug("xmlDocWorkFlowInitPageAdvanced(): nextPageElem.filepath: " + nextPageElem.filepath + "\n");
    }
    if (gSamlTokenCreateWorkFlowWizardElem.xmldoc) {
    	nextPageElem.xmldoc = gSamlTokenCreateWorkFlowWizardElem.xmldoc;
    }

    // XmlDSigToolFormUtil.logTrace("xmlDocWorkFlowInitPageAdvanced():................End.\n");
}
