/* @(#) $Id: XmlDigitalSignatureForm.js,v 1.20 2013/05/23 22:11:30 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var XmlDigitalSigTool = {
    mMaxLogLevel		: 2,
    log : function(level, msg)
    {
	if (level > XmlDigitalSigTool.mMaxLogLevel) {
            return;
        }
        dump(msg + "\n");
    },

    dump : function(msg)
    {
        XmlDigitalSigTool.log(1, msg);
    },
    logError : function(msg)
    {
        XmlDigitalSigTool.log(2, msg);
    },
    logTrace : function(msg)
    {
        XmlDigitalSigTool.log(4, msg);
    },
    logDebug : function(msg)
    {
        XmlDigitalSigTool.log(8, msg);
    },
    lastMethod : function () 
    {
    }
};


var gXmlDSigInputFileIsSignedElem;
var gXmlDSigInputFilePickerElem;
var gXmlDSigResignRowElem;
var gXmlDSigResignElem;

var gXmlDSigSignatureOverlayElem;
var gXmlDSigEditorElem;

var gXmlDSigSignedOutDocGridElem;

var gXmlDSigSignedOutFilePickerRowElem;
var gXmlDSigSignedOutFilePickerElem;
var gXmlDSigSignedOutDocVerifyElem;
var gXmlDSigEnableEncryptRowElem;

// var gXmlParser;
// var gXmlSerializer;

function xmldsigffext_initVerifyFormXULElems()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_initVerifyFormXULElems():................Start.");

    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    gXmlDSigInputFilePickerElem		= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.path");
    gXmlDSigInputFileIsSignedElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.issigned");
    gXmlDSigResignRowElem		= document.getElementById("xmldsigffext.form.sign.resign.row");
    gXmlDSigResignElem			= document.getElementById("xmldsigffext.form.sign.resign");
    // xmlDSigSignedOutDocGridElem.hidden = false;


    gXmlDSigSignatureOverlayElem	= document.getElementById("xmldsigffext.form.xmlsig.overlay");
    gXmlDSigEditorElem		= document.getElementById("xmldsigffext.form.signature.box");

    gXmlDSigSignedOutDocGridElem 	= document.getElementById("xmldsigffext.form.xmlsig.out.doc.grid"); 

    gXmlDSigSignedOutFilePickerRowElem = document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.row"); 
    gXmlDSigSignedOutFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.path"); 
    gXmlDSigSignedOutDocVerifyElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.verify"); 

    // gXmlDSigEnableEncryptRowElem 	= document.getElementById("xmldsigffext.form.encrypt.enable.row"); 

    gXmlDSigInputFilePickerElem.addEventListener('command', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('change', xmldsigffext_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('popuphiding', xmldsigffext_xmlDocFileChangeHandler, false);

    // xmldsigffext_xmlDocFileChangeHandler();
    xmldsigffext_initSignVerifySig();

    // gXmlParser = new DOMParser();
    // gXmlSerializer = new XMLSerializer();


    // XmlDigitalSigTool.logTrace("xmldsigffext_initVerifyFormXULElems():................End.");
}

function xmldsigffext_initSignVerifySig()
{
    gXmlDSigSignatureOverlayElem.hidden = true;
}

function xmldsigffext_doOnloadInitSignParam(/* String */ inXmlFilePath, /* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_doOnloadInitSignParam():................Start.");
    // xmldsigffext_initVerifyFormXULElems();

    XmlDigitalSigTool.logDebug("inXmlFilePath: " + inXmlFilePath + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
		"");
    if (inXmlFilePath) {
	if ((inXmlFilePath.indexOf("http://") == 0) 
	    || (inXmlFilePath.indexOf("https://") == 0) 
	    || (inXmlFilePath.indexOf("file://") == 0) 
	    ) {
	    xmldsigffext_inputXmlDocURIChangeHandler(inXmlFilePath);
	    return;
    	}
    }


    if (inXmlFilePath) {
    	gXmlDSigInputFilePickerElem.value = inXmlFilePath;
	gXmlDSigInputFilePickerElem.disabled = true;
    }


    xmldsigffext_xmlDocFileChangeHandler(null);
    /*
    if (aSelectedSignerCert) {
    	// xmldsigffext_setUserCredential(aSelectedSignerCert);
    }
    */

    if (outXmlFilePath) {
    	gXmlDSigSignedOutFilePickerElem.value = outXmlFilePath;
	gXmlDSigSignedOutFilePickerElem.disabled = true;
    }
    XmlDigitalSigTool.logTrace("xmldsigffext_doOnloadInitSignParam():................End.");
}

function xmldsigffext_setInputXMLFilePath(xmlFilePath)
{
    gXmlDSigInputFilePickerElem.value = xmlFilePath;
}


function xmldsigffext_enableForUnsignedXmlDoc()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForUnsignedXmlDoc():................Start.");

    // xmldsigffext_enabledSignedInfo(true);

    gXmlDSigInputFileIsSignedElem.hidden = true;

    // gXmlDSigResignRowElem.hidden = true;
    // gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForSign();

    gXmlDSigSignedOutFilePickerRowElem.hidden = false;
    // gXmlDSigEnableEncryptRowElem.hidden = false;
    gXmlDSigSignedOutDocGridElem.hidden = false;

    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForUnsignedXmlDoc():................End.");
}


function xmldsigffext_enableForSignedXmlDoc()
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForSignedXmlDoc():................Start.");

    gXmlDSigInputFileIsSignedElem.hidden = false;

    gXmlDSigResignRowElem.hidden = false;
    gXmlDSigResignElem.checked = false;

    xmldsigffext_enableForVerify();

    gXmlDSigSignedOutDocGridElem.hidden = true;
    gXmlDSigSignedOutFilePickerRowElem.hidden = true;
    // gXmlDSigEnableEncryptRowElem.hidden = true;

    // XmlDigitalSigTool.logTrace("xmldsigffext_enableForSignedXmlDoc():................End.");
}

function xmldsigffext_displayXmlDoc(aXmlDoc)
{
    XmlDigitalSigTool.logTrace("xmldsigffext_displayXmlDoc():................Start.");

    gXmlDSigSignatureOverlayElem.hidden = false;
    try {
    	gXmlDSigEditorElem.displayXmlDoc(aXmlDoc);
    } catch (ex) {
    	XmlDigitalSigTool.logError("xmldsigffext_displayXmlDoc(): gXmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "");
    	alert("xmldsigffext_displayXmlDoc(): failed to create and display XML signature - ex: " + ex + "");
    	gXmlDSigSignatureOverlayElem.hidden = true;
	return;
    }


    var isSignedXMLDoc = gXmlDSigEditorElem.isSignedXmlDoc;
    XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): isSignedXMLDoc: " + isSignedXMLDoc + "");
    XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): gXmlDSigJsonParams.signerX509Cert: " + gXmlDSigJsonParams.signerX509Cert + "");
    if (!isSignedXMLDoc && gXmlDSigJsonParams.signerX509Cert) {
    	try {
	    gXmlDSigEditorElem.signerCert = gXmlDSigJsonParams.signerX509Cert;
	} catch (ex) {
	    XmlDigitalSigTool.logError("xmldsigffext_displayXmlDoc(): gXmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "");
	}
    }

    gXmlDSigResignRowElem.hidden = !isSignedXMLDoc;
    if (isSignedXMLDoc) {
    	xmldsigffext_enableForSignedXmlDoc();

    	gXmlDSigResignElem.disabled = false;
	var credentialType = gXmlDSigEditorElem.credentialType;
    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): credentialType: " + credentialType + "");
	if ("certificate" == credentialType) {
	    var isUserCert = false;
	    var signerCert = gXmlDSigEditorElem.docSignerCert;
	    if (signerCert) {
	    	isUserCert = gX509CertDBUtil.isUserCert(signerCert);
    	    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): signerCert: " + signerCert.nickname + " isUserCert: " + isUserCert + "");
	    }
	    if (!isUserCert) {
    	    	XmlDigitalSigTool.logDebug("xmldsigffext_displayXmlDoc(): signer cert is does not have private key in CertDB - disabling editing of signature.");
    	    	gXmlDSigResignElem.disabled = true;
	    }
	}
	else {
	    gXmlDSigEditorElem.signerSharedKey = "";
	}
    }
    else {
    	xmldsigffext_enableForUnsignedXmlDoc();
    	// gXmlDSigResignRowElem.hidden = true;
	gXmlDSigSignedOutFilePickerElem.value = "";
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_displayXmlDoc():................End.");
}

function xmldsigffext_xmlDocFileChangeHandler(ev)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_xmlDocFileChangeHandler():................Start.");


    var xmlDSigInputFilePickerElem = gXmlDSigInputFilePickerElem;
    if (ev) {
    	xmlDSigInputFilePickerElem = ev.currentTarget;
    }
    xmldsigffext_inputXmlDocFileChangeHandler(xmlDSigInputFilePickerElem, ev);
    
    // XmlDigitalSigTool.logTrace("xmldsigffext_xmlDocFileChangeHandler():................End.");
}

function xmldsigffext_inputXmlDocFileChangeHandler(aXmlDSigInputFilePickerElem, ev)
{

    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................Start.");
    
    gXmlDSigSignatureOverlayElem.hidden = true;
    gXmlDSigSignedOutDocVerifyElem.hidden = true;

    var inputXmlFile = gXmlDSigInputFilePickerElem.file;
    if (inputXmlFile == null) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
    	return;
    }
    if (!inputXmlFile.exists()) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	return;
    }
    if (inputXmlFile.fileSize == 0) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Zero-length XML file - pick another one.");
    	return;
    }
    XmlDigitalSigTool.logDebug("xmldsigffext_inputXmlDocFileChangeHandler(): inXmlFilePath: " + gXmlDSigInputFilePickerElem.filepath + "");


    var /* nsIDOMDocument */ xmlDoc = null;
    try {
    	xmlDoc = gXmlDSigTool.readXMLDocFromFile(inputXmlFile);
    } catch (ex) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): gXmlDSigTool.readXMLDocFromFile() failed - Not a valid XML file - parsing error.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): gXmlDSigTool.readXMLDocFromFile() failed - Not a valid XML file - parsing error.");
    	return;
    }
    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................10.");

    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Not a valid XML file.");
    	return;
    }
    if (xmlDoc.documentElement.tagName == "parsererror") {
    	alert("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.");
    	return;
    }
    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................20.");
    gXmlDSigInputFilePickerElem.xmlDoc = xmlDoc;

    /*
    setTimeout(function() {
    	xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);
    }, 100);
    */
    xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);


    XmlDigitalSigTool.logTrace("xmldsigffext_inputXmlDocFileChangeHandler():................End.");
}

function xmldsigffext_inputXmlDocURIChangeHandler(aXmlDSigInputURISpec, ev)
{
    var /* nsIDOMDocument */ xmlDoc = gXmlDSigTool.readXMLDocFromURIPath(aXmlDSigInputURISpec);
    if (!xmlDoc) {
    	alert("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	XmlDigitalSigTool.logError("xmldsigffext_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	return;
    }
    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.xmlsig.in.doc.grid"); 
    xmlDSigSignedOutDocGridElem.hidden = true;

    xmldsigffext_displayXmlDoc(xmlDoc);
}

function xmldsigffext_handleModifySignature(modifySigCheckBoxElem)
{
    // XmlDigitalSigTool.logTrace("xmldsigffext_handleModifySignature():................End.");

    if (modifySigCheckBoxElem.checked) {
	gXmlDSigEditorElem.enableModifySignature(modifySigCheckBoxElem.checked);
	gXmlDSigSignedOutFilePickerElem.value = "";
    	xmldsigffext_enableForUnsignedXmlDoc();
    }
    else {
    	xmldsigffext_displayXmlDoc(gXmlDSigInputFilePickerElem.xmlDoc);
    	xmldsigffext_enableForSignedXmlDoc();
    }
    // XmlDigitalSigTool.logTrace("xmldsigffext_handleModifySignature():................End.");
}


function xmldsigffext_autoSelectOutSignedFile(/* nsILocalFile */ inputXMLFile)
{
    var outSignedFileName = null;

    outSignedFileName = "TmpXMLFile.xml";
    if (inputXMLFile) {
    	outSignedFileName = inputXMLFile.leafName;
    }
    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
    	outSignedFileName =
			(gXmlDSigEditorElem.signerAlias?gXmlDSigEditorElem.signerAlias:"UserX") + 
			/*
			"_" + gXmlDSigEditorElem.credentialType + 
			*/
			"_" + gXmlDSigEditorElem.signerKeyType + 
			"_" + gXmlDSigEditorElem.signatureType + 
			"_" + gXmlDSigEditorElem.canonicalizationMethodName + 
			"_" + inputXMLFile.leafName + 
			"";
    	// XmlDigitalSigTool.logDebug("xmldsigffext_autoSelectOutSignedFile(): outSignedFileName: " + outSignedFileName + "");
    }
    
    return xmldsigffext_autoSelectOutFile(gXmlDSigSignedOutFilePickerElem, outSignedFileName);
}

function xmldsigffext_previewXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_previewXMLDoc():..................Start.");

    var previewFilePickerElem = document.getElementById('xmldsigffext.form.preview.xmldoc.filepicker');
    gXmlDSigEditorElem.previewXMLDoc(previewFilePickerElem);

    XmlDigitalSigTool.logTrace("xmldsigffext_previewXMLDoc():..................End.");
}

/* nsIDOMDocument */
function xmldsigffext_signXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDoc():................Start.");

    var signedXmlDoc = null;
    signedXmlDoc = gXmlDSigEditorElem.signXMLDoc();
    if (!signedXmlDoc) {
    	return null;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDoc():................End.");
    return signedXmlDoc;
}

function xmldsigffext_signXMLDocToFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocToFile():................Start.");

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(gXmlDSigInputFilePickerElem.file);
    }
    outSignedXmlDocFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXmlDocFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLDocToFile(): path to output signed XML document is missing or invalid.");
    	throw ("xmldsigffext_signXMLDocToFile(): path to output signed XML document is missing or invalid.");
    }
    // XmlDigitalSigTool.logDebug("xmldsigffext_signXMLDocToFile(): outSignedXmlDocFile: " + outSignedXmlDocFile.path + "");


    // Create signed XML doc 
    outSignedXmlDocFile = gXmlDSigEditorElem.signXMLDocToFile(gXmlDSigSignedOutFilePickerElem);
    if (outSignedXmlDocFile) {
    	gXmlDSigSignedOutFilePickerElem.refresh();
    	gXmlDSigSignedOutDocVerifyElem.hidden = false;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLDocToFile():................End.");
    return outSignedXmlDocFile;
}

function xmldsigffext_verifySignedXMLDoc()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDoc():................Start.");

    var /* nsIDOMDocument */ signedXmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;
    // XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDoc(): signedXmlDoc: " + signedXmlDoc + "");
    if (!signedXmlDoc) {
    	// alert("Input signed XML file is missing.");
    	XmlDigitalSigTool.logDebug("xmldsigffext_verifySignedXMLDoc(): No input XML file is selected.");
    	throw("xmldsigffext_verifySignedXMLDoc(): No input XML file is selected.");
    }

    var isPassed = false;
    var errorMsg = {};
    isPassed = gXmlDSigEditorElem.verifyXMLDoc(errorMsg);
    if (!isPassed) {
    	errorMessage = errorMsg.value || "";
	if (errorMessage) {
	    alert("XML Signature verification failed - " + errorMessage + "");
	}
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLDoc():................End.");
    return isPassed;
}


function xmldsigffext_signXMLFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFile():................Start.");


    var /* nsIPersistentProperties */ xmlSignatureProps = gXmlDSigEditorElem.getSignatureProperties();
    var /* nsIPersistentProperties */ xmlSigProps = Components.classes["@mozilla.org/persistent-properties;1"].
                    createInstance(Components.interfaces.nsIPersistentProperties);

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): No input XML file is selected.");
    	alert("xmldsigffext_signXMLFile(): No input XML file is selected.");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmldsigffext_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	XmlDigitalSigTool.logError("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.");
    	alert("xmldsigffext_signXMLFile(): failed to get outSignedXMLFile.");
        return null;
    }
    XmlDigitalSigTool.logDebug("xmldsigffext_signXMLFile(): outSignedXMLFile: " + outSignedXMLFile.path + "");

    outSignedXMLFile = gXmlDSigEditorElem.signXMLDocToFile(gXmlDSigSignedOutFilePickerElem);
    if (outSignedXMLFile) {
    	gXmlDSigSignedOutFilePickerElem.refresh();
    	gXmlDSigSignedOutDocVerifyElem.hidden = false;
    }

    XmlDigitalSigTool.logTrace("xmldsigffext_signXMLFile():................End.");
    return outSignedXMLFile;
}

function propmptAndGetPassword(aPromptWinTitle, aPromptMsg)
{
    var checkStateMsg = null;
    var checkStateObj = new Object();
    checkStateObj.value = null;
    var passwordObj = new Object();
    passwordObj.value = null;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService();
    promptService = promptService.QueryInterface(Components.interfaces.nsIPromptService);
    var dialogOk = promptService.promptPassword(
			window,
			aPromptWinTitle,
			aPromptMsg,
			passwordObj,
			checkStateMsg,
			checkStateObj
		     	);
    if (!dialogOk) {
	return null;
    }
    return passwordObj.value;
}

function xmldsigffext_verifySignedXMLFile()
{
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFile():................Start.");

    var isPassed = false;
    var errorMsg = {};
    // isPassed = gXmlDSigEditorElem.verifyXMLFile(errorMsg);
    isPassed = gXmlDSigEditorElem.verifyXMLDoc(errorMsg);
    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFile(): isPassed: " + isPassed);

    XmlDigitalSigTool.logTrace("xmldsigffext_verifySignedXMLFile():................End.");
    return isPassed;
}


function xmldsigffext_loadAndVerifySignedDoc()
{
    xmldsigffext_setInputXMLFilePath(gXmlDSigSignedOutFilePickerElem.value);
    gXmlDSigSignedOutFilePickerElem.value = "";
    xmldsigffext_xmlDocFileChangeHandler();
}

