/* @(#) $Id: XmlMultiDigitalSigTool.js,v 1.10 2011/07/02 17:14:10 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var gParams = null;

var gVerifyTabCmdButtonElem;
var gVerifyAllCmdButtonElem;
var gPreviewTabCmdButtonElem;
var gSignTabCmdButtonElem;
var gSaveAllCmdButtonElem;

// var gXmlParser;
// var gXmlSerializer;

var /* alrIXPXmlDSigTool  */ gXmlDSigTool = null;

var alreadyInit = false;

function xmlmultidsigtool_initOnLoad()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initOnLoad():................Start.");

    if (alreadyInit) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initOnLoad():................End(0).");
    	return;
    }
    alreadyInit = true;

    XmlMultiDSigUtil.initXPCOMServices();

    gVerifyTabCmdButtonElem = document.getElementById('xmldsigffext.multisig.cmd.verifytab');
    gVerifyAllCmdButtonElem = document.getElementById('xmldsigffext.multisig.cmd.verify');
    gPreviewTabCmdButtonElem = document.getElementById('xmldsigffext.multisig.cmd.previewtab');
    gSignTabCmdButtonElem = document.getElementById('xmldsigffext.multisig.cmd.signtab');
    gSaveAllCmdButtonElem = document.getElementById('xmldsigffext.multisig.cmd.saveall');

    try {
    	xmlmultidsigtool_initVerifyFormXULElems();
    	xmlmultidsigtool_showVerifyForm();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_initOnLoad(): ex - " + ex + "");
	return;
    }

    try {
    	xmlmultidsigtool_initParamsOnLoad();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_initOnLoad(): ex - " + ex + "");
	return;
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initOnLoad():................End.");
}


function xmlmultidsigtool_initParamsOnLoad()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initParamsOnLoad():................Start.");

    if ((!window.arguments) || (window.arguments.length == 0) || !window.arguments[0]) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initParamsOnLoad():................End(0).");
    	return false;
    }

    var dialogParams = null;
    dialogParams = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);

    if (!dialogParams) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initParamsOnLoad():................End(1).");
    	return false;
    }
    gParams = dialogParams;

    var multiSigJsonParams = XmlMultiDSigUtil.multiSigDialogParams2JsonParams(dialogParams);

    xmlmultidsigtool_doOnloadInitSignParam(multiSigJsonParams);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initParamsOnLoad():................End.");
    return true;
}

function xmlmultidsigtool_handleTestMultiSignatureParams()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleTestMultiSignatureParams():................Start.");

    var pkiParams = Components.classes["@mozilla.org/security/pkiparamblock;1"]
    			.createInstance(Components.interfaces.nsIPKIParamBlock);
    var dialogParams = pkiParams.QueryInterface(Components.interfaces.nsIDialogParamBlock);
    	pkiParams.setISupportAtIndex(1, null);	// 
	dialogParams.SetInt(0, 0);		// dialog close option - accept(1)/cancel(0)
	dialogParams.SetInt(1, 0);		// number of string paramaters
	dialogParams.SetInt(2, 0);		// number of certs

    var multiSigJsonParams = {
		/*
		"contentElementURI"	: contentElementURI,
		*/
		"signatureType"		: gXmlMultiSigDocParams.signatureType,
		"credentialType"	: gXmlMultiSigDocParams.credentialType,
		"canonicalizationMethod" : gXmlMultiSigDocParams.canonicalizationMethod,
		/*
		"totSignerX509CertCnt"	: signerCnt,
		"signerX509CertList"	: signerX509CertList
		*/
		"inputXmlDocFilePath"	: gXmlMultiSigDocParams.inputXmlDocFilePath
	};
    XmlMultiDSigUtil.dumpMultiSigJsonParams(multiSigJsonParams);
    XmlMultiDSigUtil.multiSigJsonParams2ToDailogParams(multiSigJsonParams, dialogParams);


    var paramDialogURL = "";
    var paramDialogURL = 'chrome://xmldsigffext/content/xmldsig/XmlMultiDigitalSigParamDialog.xul';
    window.openDialog(paramDialogURL,
    			'_blank',
			'chrome,centerscreen,resizable,modal,titlebar',
			dialogParams
			);

    if (dialogParams.GetInt(0) == 0) { // Selected Cancel or failed.
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleTestMultiSignatureParams():................End(0).");
    	return;
    }

    var multiSigJsonParams = XmlMultiDSigUtil.multiSigDialogParams2JsonParams(dialogParams);
    XmlMultiDSigUtil.dumpMultiSigJsonParams(multiSigJsonParams);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleTestMultiSignatureParams():................30.");

    /*
    var signerX509Cert = (multiSigJsonParams.signerX509CertList.length > 0) ? multiSigJsonParams.signerX509CertList[0] : null;
    var dialogResult = XmlMultiDSigUtil.cmdSignXmlDoc(
    				multiSigJsonParams.inputXmlDocFilePath,
    				multiSigJsonParams.outXmlDocFilePath,
				signerX509Cert
				);
    var multiSigDialogParams = XmlMultiDSigUtil.getTestMultiSigDialogParams();
    var inputXmlDoc = XmlMultiDSigUtil.readXMLDocFromFilePath(multiSigJsonParams.inputXmlDocFilePath);
    var presignedXmlDoc = XmlMultiDSigUtil.cmdAddSignerToXmlDoc(inputXmlDoc, multiSigJsonParams);
    */

    xmlmultidsigtool_doOnloadInitSignParam(multiSigJsonParams);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleTestMultiSignatureParams():................End.");
}

function xmlmultidsigtool_showSaveForm()
{
    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showSaveForm():................Start.");

    // gSignTabCmdButtonElem.hidden = false;
    gSaveAllCmdButtonElem.hidden = false;
    gVerifyAllCmdButtonElem.hidden = true;

    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showSaveForm():................End.");
}

function xmlmultidsigtool_showSignForm()
{
    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showSignForm():................Start.");

    // gSignTabCmdButtonElem.hidden = false;
    gSaveAllCmdButtonElem.hidden = false;
    gVerifyAllCmdButtonElem.hidden = true;

    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showSignForm():................End.");
}

function xmlmultidsigtool_showVerifyForm()
{
    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showVerifyForm():................Start.");

    // gSignTabCmdButtonElem.hidden = true;
    gSaveAllCmdButtonElem.hidden = true;
    gVerifyAllCmdButtonElem.hidden = false;

    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_showVerifyForm():................End.");
}

function xmlmultidsigtool_enableForVerify()
{
    xmlmultidsigtool_showVerifyForm();
}


function xmlmultidsigtool_enableForSign()
{
    xmlmultidsigtool_showSignForm();
}

function xmlmultidsigtool_enableForResign()
{
    xmlmultidsigtool_showSignForm();
}

function xmlmultidsigtool_enableForSave()
{
    xmlmultidsigtool_showSaveForm();
}

function xmlmultidsigtool_cmdVerifyTab()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdVerifyTab():..................Start.");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }
    if (!XmlMultiDSigUtil.mXmlDSigTool) {
    	alert(XPILoadErrorMessage1 + "\n" + XPILoadErrorMessage2);
    	// window.close();
	return;
    }

    var isPassed = false;
    try {
    	isPassed = xmlmultidsigtool_verifyTabSignedXMLDoc();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdVerifyTab(): failed to verify signed XML file - ex : " + ex + "");
    	alert("Failed to verify signed XML file - ex : " + ex + "");
	return;
    }
    /*
    if (isPassed) {
    	alert("xmlmultidsigtool_cmdVerifyTab(): successfully verified the signed XML.");
    }
    else {
    	alert("xmlmultidsigtool_cmdVerifyTab(): failed to verify the signed XML.");
    }
    */

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdVerifyTab():..................End.");
}

function xmlmultidsigtool_cmdVerifyAll()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdVerifyAll():..................Start.");
    if (gParams) {
	// Falure by default
        gParams.SetInt(0, 0);
    }
    if (!XmlMultiDSigUtil.mXmlDSigTool) {
    	alert(XPILoadErrorMessage1 + "\n" + XPILoadErrorMessage2);
    	// window.close();
	return;
    }
    var closeButtonElem = document.getElementById('xmldsigffext.multisig.cmd.close');
    var cancelButtonElem = document.getElementById('xmldsigffext.multisig.cmd.cancel');


    var isPassed = false;
    try {
    	isPassed = xmlmultidsigtool_verifySignedXMLDoc();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdVerifyAll(): failed to verify signed XML file - ex : " + ex + "");
    	alert("Failed to verify signed XML file - ex : " + ex + "");
	return;
    }
    if (isPassed) {
    	// alert("xmlmultidsigtool_cmdVerifyAll(): successfully verified the signed XML.");
    	closeButtonElem.hidden = false;
    	cancelButtonElem.hidden = true;
    	if (gParams) {
            gParams.SetInt(1, 1); // verification passes
	}
    }
    else {
    	// alert("xmlmultidsigtool_cmdVerifyAll(): failed to verify the signed XML.");
    	if (gParams) {
            gParams.SetInt(1, 0); // verification failed.
	}
    }

    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdVerifyAll():..................End.");
}

function xmlmultidsigtool_cmdPreviewTab()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdPreviewTab():..................Start.");

    xmlmultidsigtool_previewTabXMLDoc();

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdPreviewTab():..................End.");
}

function xmlmultidsigtool_cmdSignTab()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdSignTab():..................Start.");
    if (gParams) {
	// Failure by default
        gParams.SetInt(0, 0);
    }
    if (!XmlMultiDSigUtil.mXmlDSigTool) {
    	alert(XPILoadErrorMessage1 + "\n" + XPILoadErrorMessage2);
    	// window.close();
	return;
    }

    var signedFile = null;
    try {
    	signedFile = xmlmultidsigtool_signTabXMLDoc();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdSignTab(): failed to sign XML document for the selected signer - ex : " + ex + "");
    	alert("Failed to sign XML document for the selected signer - ex : " + ex);
	return;
    }
    if (!signedFile) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdSignTab(): failed to sign XML document for the selected signer.");
    	alert("Failed to sign XML document for the selected signer.");
	return;
    }
    // alert("xmlmultidsigtool_cmdSignTab(): Successfully created the signed XML.");
    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdSignTab():..................End.");
}

function xmlmultidsigtool_cmdSaveAll()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdSaveAll():..................Start.");
    if (gParams) {
	// Failure by default
        gParams.SetInt(0, 0);
    }
    if (!XmlMultiDSigUtil.mXmlDSigTool) {
    	alert(XPILoadErrorMessage1 + "\n" + XPILoadErrorMessage2);
    	// window.close();
	return;
    }

    var signedFile = null;
    try {
    	signedFile = xmlmultidsigtool_saveSignedXMLDocToFile();
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdSaveAll(): failed to save the signed XML document - ex : " + ex + "");
    	alert("Failed to save the signed XML document.");
	return;
    }
    if (!signedFile) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_cmdSaveAll(): failed to create signed XML file");
    	alert("Failed to save the signed XML document.");
	return;
    }

    var closeButtonElem = document.getElementById('xmldsigffext.multisig.cmd.close');
    var cancelButtonElem = document.getElementById('xmldsigffext.multisig.cmd.cancel');

    closeButtonElem.hidden = false;
    cancelButtonElem.hidden = true;

    alert("Successfully created the signed XML.");
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_cmdSaveAll(): Successfully created the signed XML.");
    if (gParams) {
	// Set success 
        gParams.SetInt(0, 1);
    	window.close();
    }
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdSaveAll():..................End.");
}

function xmlmultidsigtool_cmdClose()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdClose():..................Start.");
    if (gParams) {
    	gParams.SetInt(0, 1);
    }
    window.close();
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdClose():..................End.");
}

function xmlmultidsigtool_cmdCancel()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdCancel():..................Start.");
    if (gParams) {
        gParams.SetInt(0, 0);
    }
    window.close();
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_cmdCancel():..................End.");
}

