/* @(#) $Id: XmlMultiDigitalSignatureForm.js,v 1.11 2012/10/03 23:08:12 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



var gXmlDSigInputFileIsSignedElem;
var gXmlDSigInputFilePickerElem;

var gXmlMultiDSigSignatureTabboxElem;
var gXmlDSigEditorElem;

var gXmlDSigSignedOutDocGridElem;

var gXmlDSigSignedOutFilePickerRowElem;
var gXmlDSigSignedOutFilePickerElem;
var gXmlDSigSignedOutDocVerifyElem;
var gXmlDSigEnableEncryptRowElem;


var gXmlMultiSigDocParams = {
    "inputXmlDocFilePath"	: null,
    "inputXmlDocFileURI"	: null,
    "inputXmlDoc"		: null,
    "contentElementURI"		: "",
    "signatureType"		: "DETACHED_SIGNATURE",
    "credentialType"		: "certificate",
    "canonicalizationMethod"	: "http://www.w3.org/TR/2001/REC-xml-c14n-20010315",
    "totSignerX509CertCnt"	: 1,
    "signerX509CertList"	: [],
    "inputMultiSigXmlDoc"	: null,
    "unsignedXmlDoc"		: null,
    "sigTemplateElem"		: null,
    "signerUnsignedXmlDocList"	: [],
    "signerSignedXmlDocList"	: [],
    "multiSignedOutXmlDoc"	: null,
    "outXmlDocFilePath"		: null
};

const gXulDocNsURI = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";


/*
var XmlMultiDSigForm = {
    mMaxLogLevel : 2,
    log : function(level, msg)
    {
	if (level > this.mMaxLogLevel) {
            return;
        }
        dump(msg + "\n");
    },

    logError : function(msg)
    {
        this.log(2, msg);
    },
    logTrace : function(msg)
    {
        this.log(4, msg);
    },
    logDebug : function(msg)
    {
        this.log(8, msg);
    }
};
*/

function xmlmultidsigtool_initVerifyFormXULElems()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initVerifyFormXULElems():................Start.");

    gXmlDSigInputFilePickerElem		= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.path");
    gXmlDSigInputFileIsSignedElem	= document.getElementById("xmldsigffext.form.sign.file.in.xmldoc.issigned");

    gSigContentElemIdRowElem		= document.getElementById("xmldsigffext.form.multisig.sign.contentid.row");
    gSigContentElemIdMenuElem		= document.getElementById("xmldsigffext.form.multisig.sign.contentid");

    gXmlMultiDSigSignatureTabboxElem	= document.getElementById("xmldsigffext.form.multisig.tabbox");

    gXmlDSigSignedOutDocGridElem 	= document.getElementById("xmldsigffext.form.multisig.out.doc.grid"); 

    gXmlDSigSignedOutFilePickerRowElem = document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.row"); 
    gXmlDSigSignedOutFilePickerElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.path"); 
    gXmlDSigSignedOutDocVerifyElem	= document.getElementById("xmldsigffext.form.sign.file.out.xmldoc.verify"); 

    // gXmlDSigEnableEncryptRowElem 	= document.getElementById("xmldsigffext.form.encrypt.enable.row"); 

    if (gSigContentElemIdMenuElem.refresh) {
    	gSigContentElemIdMenuElem.refresh();
    }

    gXmlDSigInputFilePickerElem.addEventListener('command', xmlmultidsigtool_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('change', xmlmultidsigtool_xmlDocFileChangeHandler, false);
    gXmlDSigInputFilePickerElem.addEventListener('popuphiding', xmlmultidsigtool_xmlDocFileChangeHandler, false);

    xmlmultidsigtool_initSignVerifySig();

    // gXmlDSigInputFilePickerElem.filepath = "/home/subrata/XMLDOC/AMSTestDoc.xml";
    gXmlDSigInputFilePickerElem.filepath = "";
    xmlmultidsigtool_inputXmlDocFileChangeHandler(gXmlDSigInputFilePickerElem);

    gXmlDSigSignedOutFilePickerElem.value = "";

    /*
    gXmlParser = new DOMParser();
    gXmlSerializer = new XMLSerializer();
    */


    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initVerifyFormXULElems():................End.");
}

function xmlmultidsigtool_initSignVerifySig()
{
    gXmlMultiDSigSignatureTabboxElem.hidden = true;
}

function xmlmultidsigtool_doOnloadInitSignParam(aMultiSigDialogJsonParams)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_doOnloadInitSignParam():................Start.");

    // Copy the dialog param into the default values
    for (var dialogParamName in aMultiSigDialogJsonParams) {
	var dialogParamValue = aMultiSigDialogJsonParams[dialogParamName];
	if (dialogParamValue) {
    	    gXmlMultiSigDocParams[dialogParamName] = dialogParamValue;
	}
    }
    // xmlmultidsigtool_dumpMultiSigJsonParams(gXmlMultiSigDocParams);

     /* String */ inXmlFilePath = aMultiSigDialogJsonParams.inputXmlDocFilePath;
     /* String */ outXmlFilePath = aMultiSigDialogJsonParams.outXmlDocFilePath;

    XmlMultiDSigUtil.logDebug("inXmlFilePath: " + inXmlFilePath + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
		"");
    if (inXmlFilePath) {
	if ((inXmlFilePath.indexOf("http://") == 0) 
	    || (inXmlFilePath.indexOf("https://") == 0) 
	    || (inXmlFilePath.indexOf("file://") == 0) 
	    ) {
	    xmlmultidsigtool_inputXmlDocURIChangeHandler(inXmlFilePath);
	    return;
    	}
    }

    if (inXmlFilePath) {
    	gXmlDSigInputFilePickerElem.value = inXmlFilePath;
	gXmlDSigInputFilePickerElem.disabled = true;
    }


    xmlmultidsigtool_xmlDocFileChangeHandler();

    if (outXmlFilePath) {
    	gXmlDSigSignedOutFilePickerElem.value = outXmlFilePath;
	gXmlDSigSignedOutFilePickerElem.disabled = true;
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_doOnloadInitSignParam():................End.");
}

function xmlmultidsigtool_setInputXMLFilePath(xmlFilePath)
{
    gXmlDSigInputFilePickerElem.value = xmlFilePath;
    xmlmultidsigtool_xmlDocFileChangeHandler();
}


function xmlmultidsigtool_enableForUnsignedXmlDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_enableForUnsignedXmlDoc():................Start.");

    gXmlDSigInputFileIsSignedElem.checked = false;
    // gSigContentElemIdRowElem.hidden = false;

    xmlmultidsigtool_enableForSign();

    gXmlDSigSignedOutFilePickerRowElem.hidden = false;
    gXmlDSigSignedOutDocGridElem.hidden = false;

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_enableForUnsignedXmlDoc():................End.");
}


function xmlmultidsigtool_enableForSignedXmlDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_enableForSignedXmlDoc():................Start.");

    gXmlDSigInputFileIsSignedElem.hidden = false;
    gXmlDSigInputFileIsSignedElem.checked = true;
    // gSigContentElemIdRowElem.hidden = true;

    xmlmultidsigtool_enableForVerify();

    gXmlDSigSignedOutDocGridElem.hidden = true;
    gXmlDSigSignedOutFilePickerRowElem.hidden = true;

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_enableForSignedXmlDoc():................End.");
}

/*
function readXMLDocFromString(aXmlDocDataStr)
{
    var xmlDoc = null;
    try {
    	xmlDoc = gXmlDSigTool.readXMLDocFromString(aXmlDocDataStr);
    } catch (ex) {
    	XmlMultiDSigUtil.logError("readXMLDocFromString(): this.mXmlParser.parseFromString() failed - ex: " + ex + "");
	throw ex;
    }
    return xmlDoc;
}
*/

function xmlmultidsigtool_inputXmlDocURIChangeHandler(aXmlDSigInputURISpec, ev)
{
    var /* nsIDOMDocument */ xmlDoc = null;
    try {
    	// xmlDoc = XmlMultiDSigUtil.mXmlDSigTool.readXMLDocFromURIPath(aXmlDSigInputURISpec);
    	xmlDoc = XmlMultiDSigUtil.readXMLDocFromURISpec(aXmlDSigInputURISpec);
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocURIChangeHandler(): XmlMultiDSigUtil.readXMLDocFromURISpec() failed - ex: " + ex);
    } 
    if (!xmlDoc) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocURIChangeHandler(): Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	alert("Failed to load XML Doc usin the URI: " + aXmlDSigInputURISpec + ".");
    	return;
    }

    var xmlDSigSignedOutDocGridElem = document.getElementById("xmldsigffext.form.multisig.in.doc.grid"); 
    xmlDSigSignedOutDocGridElem.hidden = true;

    gXmlMultiSigDocParams.inputXmlDocFileURI = aXmlDSigInputURISpec;
    gXmlMultiSigDocParams.inputXmlDoc = xmlDoc;
    xmlmultidsigtool_handleContentIdMenuChange(gXmlDSigInputFilePickerElem);

    // xmlmultidsigtool_displayMultiSignXmlDoc(gXmlMultiSigDocParams);
}

function xmlmultidsigtool_xmlDocFileChangeHandler(ev)
{
    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_xmlDocFileChangeHandler():................Start.");


    var xmlDSigInputFilePickerElem = gXmlDSigInputFilePickerElem;
    if (ev) {
    	xmlDSigInputFilePickerElem = ev.currentTarget;
    }
    xmlmultidsigtool_inputXmlDocFileChangeHandler(xmlDSigInputFilePickerElem, ev);
    
    // XmlMultiDSigUtil.logTrace("xmlmultidsigtool_xmlDocFileChangeHandler():................End.");
}

function xmlmultidsigtool_inputXmlDocFileChangeHandler(aXmlDSigInputFilePickerElem, ev)
{

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_inputXmlDocFileChangeHandler():................Start.");
    if (ev) {
    	XmlMultiDSigUtil.logDebug("xmlmultidsigtool_inputXmlDocFileChangeHandler(): ev.type : " + ev.type + "");
    }
    
    gSigContentElemIdRowElem.hidden = true;
    gSigContentElemIdMenuElem.docRootElem = null;

    gXmlMultiDSigSignatureTabboxElem.hidden = true;
    gXmlDSigSignedOutDocVerifyElem.hidden = true;
    gXmlDSigSignedOutDocGridElem.hidden = true;

    var inputXmlFile = gXmlDSigInputFilePickerElem.file;
    if (inputXmlFile == null) {
    	// alert("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
	if (ev) {
    	    XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Input XML file path is missing.");
	}
    	return;
    }
    if (!inputXmlFile.exists()) {
    	alert("Input XML file does not exists.");
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Input XML file does not exists.");
    	return;
    }

    var /* nsIDOMDocument */ xmlDoc = null;
    try {
    	// xmlDoc = XmlMultiDSigUtil.mXmlDSigTool.readXMLDocFromFile(inputXmlFile);
    	xmlDoc = XmlMultiDSigUtil.readXMLDocFromFile(inputXmlFile);
    } catch (ex) {
    	alert("Not a valid input XML file - parsing error.");
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Not a valid input XML file - parsing error - ex:" + ex);
    	return;
    }
    if (!xmlDoc) {
    	alert("Not a valid input XML file.");
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Not a valid XML file.");
    	return;
    }
    if (xmlDoc.documentElement.tagName == "parsererror") {
    	alert("Parsing of input XML file failed.");
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): Parsing of  XML file failed.");
    	return;
    }

    gXmlDSigInputFilePickerElem.xmlDoc = xmlDoc;

    gXmlDSigSignedOutDocGridElem.hidden = false;

    try {
    	gXmlMultiSigDocParams.inputXmlDocFilePath = gXmlDSigInputFilePickerElem.filepath;
    	gXmlMultiSigDocParams.inputXmlDoc = gXmlDSigInputFilePickerElem.xmlDoc;

    	// XmlMultiDSigUtil.dump("xmlmultidsigtool_inputXmlDocFileChangeHandler(): xmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(xmlDoc) + "\n");
    	gSigContentElemIdMenuElem.docRootElem = gXmlMultiSigDocParams.inputXmlDoc.documentElement;
    	// gSigContentElemIdMenuElem.selectAnyNonRootElemWithId();

    	var xmlDocSigElemList = xmlDoc.getElementsByTagName("ds:Signature");
    	if (xmlDocSigElemList.length <= 0) {
    		xmlDocSigElemList = xmlDoc.getElementsByTagName("Signature");
    	}
    	XmlMultiDSigUtil.logDebug("xmlmultidsigtool_inputXmlDocFileChangeHandler(): xmlDocSigElemList.length: " + xmlDocSigElemList.length + "");
    	if (xmlDocSigElemList.length <= 0) {
		gSigContentElemIdRowElem.hidden = false;
		// xmlmultidsigtool_handleContentIdMenuChange(gSigContentElemIdMenuElem);
    		setTimeout(function() {
			xmlmultidsigtool_handleContentIdMenuChange(gSigContentElemIdMenuElem);
    		}, 500);
    	}
    	else {
		gSigContentElemIdRowElem.hidden = true;
    		xmlmultidsigtool_processInputXmlDocFile();
    	}
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_inputXmlDocFileChangeHandler(): ex: " + ex + "");
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_inputXmlDocFileChangeHandler():................End.");
}

function xmlmultidsigtool_handleContentIdMenuChange(aContentIdMenuElem, ev)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleContentIdMenuChange():................Start.");

    var contentElementURI = aContentIdMenuElem.value;
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_handleContentIdMenuChange(): contentElementURI: " + contentElementURI + "");
    if (contentElementURI && (contentElementURI != "")) {
    	gXmlMultiSigDocParams.contentElementURI  = contentElementURI;
    }
    else {
	if (ev) {
    	    alert("You cannot choose root document element for multiple signatures. You must select a valid element id under the document root.");
	}
	return;
    }

    xmlmultidsigtool_processInputXmlDocFile();

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleContentIdMenuChange():................End.");
}

function xmlmultidsigtool_handleSigEditorEvents(ev)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorEvents():................Start.");

    var xmlSigEditorElem = ev.currentTarget;

    var origTargetElem = ev.originalTarget;
    var btnCode = ev.button;
    if (btnCode != 0) { // We are lloking clicking of Sign using the left button
    	return;
    }

    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_handleSigEditorEvents(): ev.type: " + ev.type + " origTargetElem.tag: " + origTargetElem.tagName);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorEvents():................End.");
}

function xmlmultidsigtool_autoSelectOutSignedFile(/* nsILocalFile */ outputXMLFile)
{
    var outSignedFileName = null;

    outSignedFileName = "TmpXMLFile.xml";
    if (outputXMLFile) {
    	outSignedFileName = outputXMLFile.leafName;
    }
    if (outSignedFileName.indexOf("_SIGNATURE") < 0) {
    	outSignedFileName = "Signed" + "_" + outputXMLFile.leafName + "";
    	// XmlMultiDSigUtil.logDebug("xmlmultidsigtool_autoSelectOutSignedFile(): outSignedFileName: " + outSignedFileName + "");
    }
    
    return XmlMultiDSigUtil.autoSelectOutFile(gXmlDSigSignedOutFilePickerElem, outSignedFileName);
}

function xmlmultidsigtool_initMultiSignedXmlDocFile(aXmlMultiSigDocParams)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initMultiSignedXmlDocFile():................Start.");

    var xmlMultiSigDocParams = aXmlMultiSigDocParams;
    // XmlMultiDSigUtil.dump("xmlmultidsigtool_getUnsignedXmlDoc(): xmlMultiSigDocParams.inputXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(xmlMultiSigDocParams.inputXmlDoc));

    var inputMultiSigXmlDoc = xmlMultiSigDocParams.inputXmlDoc.cloneNode(true);
    xmlMultiSigDocParams.inputMultiSigXmlDoc = inputMultiSigXmlDoc;

    var xmlDocSigElemList = inputMultiSigXmlDoc.getElementsByTagName("ds:Signature");
    if (xmlDocSigElemList.length <= 0) {
    	xmlDocSigElemList = inputMultiSigXmlDoc.getElementsByTagName("Signature");
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_initMultiSignedXmlDocFile(): xmlDocSigElemList.length: " + xmlDocSigElemList.length + "");
    if (xmlDocSigElemList.length > 0) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initMultiSignedXmlDocFile():................End(0).");
    	return;
    }

    var sigElem = XmlMultiDSigUtil.getDefaultSigTemplate(xmlMultiSigDocParams);
    // sigElem = inputMultiSigXmlDoc.adoptNode(sigElem);
    sigElem = inputMultiSigXmlDoc.importNode(sigElem, true);
    for (var i = 0; i < xmlMultiSigDocParams.totSignerX509CertCnt; i++) {
    	var signerX509cert = null;
	if (i < xmlMultiSigDocParams.signerX509CertList.length) {
	    signerX509cert = xmlMultiSigDocParams.signerX509CertList[i];
	}
	if (signerX509cert) {
	    // TODO: Append the X509Data/X509Certificate and X509Data/X509SubjectName to KeyInfo element
	}
	inputMultiSigXmlDoc.documentElement.appendChild(sigElem);
    }

    // XmlMultiDSigUtil.dump("xmlmultidsigtool_getUnsignedXmlDoc(): inputMultiSigXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(inputMultiSigXmlDoc));
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_initMultiSignedXmlDocFile():................End.");
}

function xmlmultidsigtool_processInputXmlDocFile()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_processInputXmlDocFile():................Start.");

    gXmlMultiSigDocParams.unsignedXmlDoc = XmlMultiDSigUtil.getUnsignedXmlDoc(gXmlMultiSigDocParams.inputXmlDoc);
    gXmlMultiSigDocParams.sigTemplateElem = XmlMultiDSigUtil.getDefaultSigTemplate(gXmlMultiSigDocParams);
    // gXmlMultiSigDocParams.inputMultiSigXmlDoc = gXmlMultiSigDocParams.inputXmlDoc.cloneNode(true);
    gXmlMultiSigDocParams.inputMultiSigXmlDoc = null;
    gXmlMultiSigDocParams.signerUnsignedXmlDocList = [];
    gXmlMultiSigDocParams.signerSignedXmlDocList = [];
    gXmlMultiSigDocParams.multiSignedOutXmlDoc = null;

    try {
    	xmlmultidsigtool_initMultiSignedXmlDocFile(gXmlMultiSigDocParams);
    } catch (ex) {
	alert("Failed to initialize the default signature parameters");
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_processInputXmlDocFile(): xmlmultidsigtool_initMultiSignedXmlDocFile() fauled - ex: " + ex);
	throw ex;
    }

    xmlmultidsigtool_displayMultiSignXmlDoc(gXmlMultiSigDocParams);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_processInputXmlDocFile():................End.");
}

function xmlmultidsigtool_displayMultiSignXmlDoc(aXmlMultiSigDocParams)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_displayMultiSignXmlDoc():................Start.");

    gXmlMultiDSigSignatureTabboxElem.hidden = false;

    // Remove existisng tab/tabpanel elements 
    var tabboxElem = document.getElementById("xmldsigffext.form.multisig.tabbox");
    var tabsElem = document.getElementById("xmldsigffext.form.multisig.tabs");
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");

    var tabElemList = tabsElem.getElementsByTagName("tab");
    if (tabElemList.length > 0) {
	for (var j = (tabElemList.length -1); j >= 0; j--) {
	    var tabElem = tabElemList.item(j);
	    tabsElem.removeChild(tabElem);
	}
    }
    while (tabpanelsElem.firstChild) {
    	tabpanelsElem.removeChild(tabpanelsElem.firstChild);
    }

    var inputMultiSigXmlDoc = aXmlMultiSigDocParams.inputMultiSigXmlDoc;
    // XmlMultiDSigUtil.dump("xmlmultidsigtool_displayMultiSignXmlDoc(): inputMultiSigXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(inputMultiSigXmlDoc) + "\n");

    var xmlDocSigElemList = inputMultiSigXmlDoc.getElementsByTagName("ds:Signature");
    if (xmlDocSigElemList.length <= 0) {
    	xmlDocSigElemList = inputMultiSigXmlDoc.getElementsByTagName("Signature");
    }

    var unsignedXmlDoc = aXmlMultiSigDocParams.unsignedXmlDoc;
    var sigTemplateElem = aXmlMultiSigDocParams.sigTemplateElem;

    if (!sigTemplateElem) {
    if (xmlDocSigElemList.length <= 0) {
    	sigTemplateElem = XmlMultiDSigUtil.getDefaultSigTemplate(gXmlMultiSigDocParams);
    }
    else {
	// Make the first available signature element as template for all other.
	// For multi-signer KeyInfo element which uniquely defines a signer
	// cannot be part of the template
    	sigTemplateElem = xmlDocSigElemList.item(0).cloneNode(true);
	var keyInfoElemList = sigTemplateElem.getElementsByTagName("ds:KeyInfo");
	if (keyInfoElemList && (keyInfoElemList.length > 0)) {
	    var keyInfoElem = keyInfoElemList.item(0);
	    while (keyInfoElem.firstChild) {
	        keyInfoElem.removeChild(keyInfoElem.firstChild);
	    }
	}
    }
    aXmlMultiSigDocParams.sigTemplateElem = sigTemplateElem;
    // XmlMultiDSigUtil.dump("xmlmultidsigtool_displayMultiSignXmlDoc(): sigTemplateElem:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(sigTemplateElem) + "\n");
    }

    var signerUnsignedXmlDoc = null;
    if (xmlDocSigElemList.length == 0) {
	xmlmultidsigtool_handleAddSigner();
    }
    else {
        for (var i = 0; i < xmlDocSigElemList.length; i++) {
    	    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_displayMultiSignXmlDoc(): xmlmultidsigtool_AddSignerTab(): i: " + i + "");
	    var sigElem = xmlDocSigElemList.item(i);

    	    signerUnsignedXmlDoc = aXmlMultiSigDocParams.unsignedXmlDoc.cloneNode(true);
	    sigElem = signerUnsignedXmlDoc.importNode(sigElem, true);
	    signerUnsignedXmlDoc.documentElement.appendChild(sigElem);
	    aXmlMultiSigDocParams.signerUnsignedXmlDocList.push(signerUnsignedXmlDoc);
	    xmlmultidsigtool_AddSignerTab(signerUnsignedXmlDoc);
        }
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_displayMultiSignXmlDoc():................End.");
}

function xmlmultidsigtool_handleSigEditorTabSelect(aTabsElem, ev)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorTabSelect():................Start.");

    var tabboxElem = document.getElementById("xmldsigffext.form.multisig.tabbox");

    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var selectedTabpanel = tabpanelsElem.selectedPanel;
    if (!selectedTabpanel) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorTabSelect():................End(0).");
    	return;
    }

    var xmlDSigEditorElem = selectedTabpanel.getElementsByTagName("XmlDocSigEditor").item(0);
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_handleSigEditorTabSelect(): selectedTabpanel.getElementsByTagName() failed to find XmlDocSigEditor.");
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorTabSelect():................End(1).");
    	return;
    }

    var isTabXmlDocSigned = xmlDSigEditorElem.isSignedXmlDoc;
    if (isTabXmlDocSigned) {
    	gPreviewTabCmdButtonElem.hidden = true;
    	gSignTabCmdButtonElem.hidden = true;
    	gVerifyTabCmdButtonElem.hidden = false;
    }
    else {
    	gPreviewTabCmdButtonElem.hidden = false;
    	gSignTabCmdButtonElem.hidden = false;
    	gVerifyTabCmdButtonElem.hidden = true;
    }

    var isInputXmlDocSigned = true;
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var xmlDSigEditorElemList = tabpanelsElem.getElementsByTagName("XmlDocSigEditor");
    for (var i = 0; i < xmlDSigEditorElemList.length; i++) {
    	var xmlDSigEditorElem = xmlDSigEditorElemList.item(i);
	isInputXmlDocSigned = (isInputXmlDocSigned && xmlDSigEditorElem.isSignedXmlDoc);
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_displayXmlDoc(): isInputXmlDocSigned: " + isInputXmlDocSigned + "");
    if (isInputXmlDocSigned) {
    	xmlmultidsigtool_enableForSignedXmlDoc();
    }
    else {
    	xmlmultidsigtool_enableForUnsignedXmlDoc();
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleSigEditorTabSelect():................End.");
}

function xmlmultidsigtool_handleAddSigner(ev)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleAddSigner():................Start.");

    var signerUnsignedXmlDoc = null;
	var sigElem = gXmlMultiSigDocParams.sigTemplateElem;

    	signerUnsignedXmlDoc = gXmlMultiSigDocParams.unsignedXmlDoc.cloneNode(true);
	sigElem = signerUnsignedXmlDoc.importNode(sigElem, true);
	signerUnsignedXmlDoc.documentElement.appendChild(sigElem);
	gXmlMultiSigDocParams.signerUnsignedXmlDocList.push(signerUnsignedXmlDoc);
	xmlmultidsigtool_AddSignerTab(signerUnsignedXmlDoc);

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleAddSigner():................End.");
}

function xmlmultidsigtool_AddSignerTab(aXmlDoc)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleAddSignature():................Start.");
    // XmlMultiDSigUtil.dump("xmlmultidsigtool_handleAddSignature(): aXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(aXmlDoc) + "\n");

    /*
		<tabbox id="xmldsigffext.form.multisig.tabbox"
		    flex="1"
		    style="border: 2px solid red;"
		    >
		    <tabs id="xmldsigffext.form.multisig.tabs"
		   	style="border: 2px solid blue;"
			>
		    	<tab id="xmldsigffext.form.multisig.tab.first"
			    label="&xmldsigffext.form.multisig.tab.first.label;"
			    />
		    </tabs>
		    <tabpanels id="xmldsigffext.form.multisig.tabpanels"
		    	flex="1"
			xstyle="border: 4px solid red;"
			>
			<tabpanel id="xmldsigffext.form.multisig.tabpanel.first" position="1"
	    		    orient="vertical"
		    	    flex="1"
			    style="border: 4px solid blue;"
			    >
			    <hbox id="xmldsigffext.form.multisig.resign.first.hbox"
			    	pack="start"
				>
				<checkbox id="xmldsigffext.form.multisig.resign.first"
				        label="&xmldsigffext.form.sign.params.editsig.label;"
				        tooltiptext="&xmldsigffext.form.sign.params.editsig.tooltip;"
				        value="true"
				        sigeditorid="xmldsigffext.form.multisig.sigeditor.first"
				        oncommand="xmlmultidsigtool_handleModifyMultiSignature(this, event); return false;"
				        sigParamName="resign"
				        />
			    </hbox>
		    	    <SignatureEditor id="xmldsigffext.form.multisig.sigeditor.first" flex="1">
			    </SignatureEditor>
			</tablepanel>
		    </tablepanels>
    */

    var tabboxElem = document.getElementById("xmldsigffext.form.multisig.tabbox");
    var tabsElem = document.getElementById("xmldsigffext.form.multisig.tabs");
    var addSignerElem = document.getElementById("xmldsigffext.form.multisig.cmd.addsig");
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");

    // TODO: Dervive the value of sigElemId from the key-info in the Signature/SignedInfo/KeyInfo,
    // it is present. If not, use the tab-position to derive sigElemId.
    var sigElemId = "" + (tabsElem.itemCount);
    var signerId = "Signer_" + sigElemId;

    var tabLabel = "Signer_" + sigElemId;
    var tabId = "xmldsigffext.form.multisig.tab." + signerId;
    var tabElem = tabsElem.insertItemAt((tabsElem.itemCount - 1), tabLabel, signerId); // add before addSigner elem
    tabElem.setAttribute("id", ("xmldsigffext.form.multisig.tab." + signerId));

    var tabpanelId = "xmldsigffext.form.multisig.tabpanel." + signerId;
    var tabpanelElem = document.createElement("tabpanel");
    tabpanelElem.setAttribute("id", tabpanelId);
    tabpanelElem.setAttribute("orient", "vertical");
    tabpanelElem.setAttribute("flex", "1");
    // tabpanelElem.setAttribute("style", "overlfow:auto");
    switch (tabsElem.itemCount) {
    	case 1 : 
    	    tabpanelElem.setAttribute("style", "border: 4px solid red;");
	    break;
    	case 2 : 
    	    tabpanelElem.setAttribute("style", "border: 4px solid orange;");
	    break;
    	case 3 : 
    	    tabpanelElem.setAttribute("style", "border: 4px solid brown;");
	    break;
    	default:
	    break;
    }
    tabpanelElem = tabpanelsElem.appendChild(tabpanelElem);

    // tabboxElem.selectedPanel = tabpanelElem;

    var sigEditorId = "xmldsigffext.form.multisig.sigeditor." + signerId;
    var sigEditorElem = document.createElementNS(gXulDocNsURI, "XmlDocSigEditor");
    sigEditorElem.setAttribute("id", sigEditorId);
    sigEditorElem = tabpanelElem.appendChild(sigEditorElem);
    // sigEditorElem.refresh();

    setTimeout(function() {
    	xmlmultidsigtool_displayXmlDoc(aXmlDoc, tabpanelElem);
    	tabboxElem.selectedTab = tabElem;
    }, 1000);

    sigEditorElem.addEventListener("command", xmlmultidsigtool_handleSigEditorEvents, false);

    // XmlMultiDSigUtil.dump("xmlmultidsigtool_handleAddSignature(): tabboxElem:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(tabboxElem) + "\n");
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_handleAddSignature():................End.");
}

function xmlmultidsigtool_displayXmlDoc(aXmlDoc, aTabPanelElem)
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_displayXmlDoc():................Start.");

    // XmlMultiDSigUtil.dump("xmlmultidsigtool_displayXmlDoc(): aXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(aXmlDoc) + "\n");

    var xmlDSigEditorElem = aTabPanelElem.getElementsByTagName("XmlDocSigEditor").item(0);
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_displayXmlDoc(): aTabPanelElem.getElementsByTagName() failed to find XmlDocSigEditor.");
    	return;
    }
    try {
	if (xmlDSigEditorElem.refresh) {
	    xmlDSigEditorElem.refresh();
	}
    	xmlDSigEditorElem.displayXmlDoc(aXmlDoc);
    } catch (ex) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_displayXmlDoc(): xmlDSigEditorElem.displayXmlDoc() failed - ex: " + ex + "");
    	alert("xmlmultidsigtool_displayXmlDoc(): failed to create and display XML signature - ex: " + ex + "");
    	// gXmlMultiDSigSignatureTabboxElem.hidden = true;
	return;
    }


    var isTabXmlDocSigned = xmlDSigEditorElem.isSignedXmlDoc;

    var isInputXmlDocSigned = true;
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var xmlDSigEditorElemList = tabpanelsElem.getElementsByTagName("XmlDocSigEditor");
    for (var i = 0; i < xmlDSigEditorElemList.length; i++) {
    	var xmlDSigEditorElem = xmlDSigEditorElemList.item(i);
	isInputXmlDocSigned = (isInputXmlDocSigned && xmlDSigEditorElem.isSignedXmlDoc);
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_displayXmlDoc(): isInputXmlDocSigned: " + isInputXmlDocSigned + "");
    if (isInputXmlDocSigned) {
    	xmlmultidsigtool_enableForSignedXmlDoc();
    }
    else {
    	xmlmultidsigtool_enableForUnsignedXmlDoc();
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_displayXmlDoc():................End.");
}

/* boolean */
function xmlmultidsigtool_verifyTabSignedXMLDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifyTabSignedXMLDoc():................Start.");
    var sigValidated = false;

    /*
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var selectedTabpanel = tabpanelsElem.selectedPanel;
    if (!selectedTabpanel) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifyTabSignedXMLDoc():................End(0).");
    	return sigValidated;
    }

    var xmlDSigEditorElem = selectedTabpanel.getElementsByTagName("XmlDocSigEditor").item(0);
    */
    var xmlDSigEditorElem = xmlmultidsigtool_getSelectSigEditor();
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_verifyTabSignedXMLDoc(): selectedTabpanel.getElementsByTagName() failed to find XmlDocSigEditor.");
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifyTabSignedXMLDoc():................End(1).");
    	return false;
    }

    sigValidated = xmlDSigEditorElem.verifyXMLDoc();
    if (sigValidated) {
    	alert("The signature for this tab is successully validated.");
    }
    else {
    	alert("The signature for this tab has failed validation.");
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifyTabSignedXMLDoc():................End.");
    return sigValidated;
}

function xmlmultidsigtool_verifySignedXMLDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifySignedXMLDoc():................Start.");

    var tabboxElem = document.getElementById("xmldsigffext.form.multisig.tabbox");
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");

    var xmlDSigEditorElemList = tabpanelsElem.getElementsByTagName("XmlDocSigEditor");
    if (xmlDSigEditorElemList.length <= 0) {
    	alert("Input XML document does not contain any signature element.");
	return;
    }

    var sigErrorTabPanel = null;
    var isSignedXmlDoc = true;
    for (var i = 0; i < xmlDSigEditorElemList.length; i++) {
    	var xmlDSigEditorElem = xmlDSigEditorElemList.item(i);
	isSignedXmlDoc = (isSignedXmlDoc && xmlDSigEditorElem.isSignedXmlDoc);
	if (!isSignedXmlDoc) {
	    sigErrorTabPanel = xmlDSigEditorElem.parentNode;
	}
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_displayXmlDoc(): isSignedXmlDoc: " + isSignedXmlDoc + "");
    if (!isSignedXmlDoc) {
	if (sigErrorTabPanel) {
	    tabboxElem.selectedItem = sigErrorTabPanel;
	}
    	alert("One or more signatures element does contain all the elements of a valid signature.");
	return;
    }

    var sigValidationMsg = "";
    var sigValidated = true;
    sigErrorTabPanel = null;
    for (var i = 0; i < xmlDSigEditorElemList.length; i++) {
    	var xmlDSigEditorElem = xmlDSigEditorElemList.item(i);
	sigValidated = (sigValidated && xmlDSigEditorElem.verifyXMLDoc());
	if (!sigValidated) {
	    sigErrorTabPanel = xmlDSigEditorElem.parentNode;
	}
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_verifySignedXMLDoc(): sigValidated: " + sigValidated + "");

    if (sigValidated) {
    	alert("All the signatures in the document are successully validated.");
    }
    else {
    	alert("One or more the signatures in the document failed validation.");
	if (sigErrorTabPanel) {
	    tabboxElem.selectedItem = sigErrorTabPanel;
	}
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_verifySignedXMLDoc():................End.");
    return sigValidated;
}

function xmlmultidsigtool_getSelectSigEditor()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_getSelectSigEditor():................Start.");

    var xmlDSigEditorElem = null;

    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var selectedTabpanel = tabpanelsElem.selectedPanel;
    if (!selectedTabpanel) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_getSelectSigEditor():................End(0).");
    	return xmlDSigEditorElem;
    }

    xmlDSigEditorElem = selectedTabpanel.getElementsByTagName("XmlDocSigEditor").item(0);
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_getSelectSigEditor(): selectedTabpanel.getElementsByTagName() failed to find XmlDocSigEditor.");
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_getSelectSigEditor():................End(1).");
    	return xmlDSigEditorElem;
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_getSelectSigEditor():................End.");
    return xmlDSigEditorElem;
}

function xmlmultidsigtool_previewTabXMLDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_previewTabXMLDoc():................Start.");

    var xmlDSigEditorElem = xmlmultidsigtool_getSelectSigEditor();
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_previewTabXMLDoc(): xmlmultidsigtool_getSelectSigEditor() failed to find XmlDocSigEditor for selected tab.");
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_previewTabXMLDoc():................End(1).");
    	return;
    }

    xmlDSigEditorElem.previewXMLDoc();

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_previewTabXMLDoc():................End.");
    return;
}

/* nsIDOMDocument */
function xmlmultidsigtool_signTabXMLDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_signTabXMLDoc():................Start.");
    var signedXmlDoc = null;

    /*
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");
    var selectedTabpanel = tabpanelsElem.selectedPanel;
    if (!selectedTabpanel) {
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_signTabXMLDoc():................End(0).");
    	return signedXmlDoc;
    }

    var xmlDSigEditorElem = selectedTabpanel.getElementsByTagName("XmlDocSigEditor").item(0);
    */
    var xmlDSigEditorElem = xmlmultidsigtool_getSelectSigEditor();
    if (!xmlDSigEditorElem) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_signTabXMLDoc(): selectedTabpanel.getElementsByTagName() failed to find XmlDocSigEditor.");
    	XmlMultiDSigUtil.logTrace("xmlmultidsigtool_signTabXMLDoc():................End(1).");
    	return signedXmlDoc;
    }

    signedXmlDoc = xmlDSigEditorElem.signXMLDoc();
    if (signedXmlDoc) {
    	alert("Successfully signed doc.");
    }
    else {
    	alert("Failed to sign doc.");
    }

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_signTabXMLDoc():................End.");
    return signedXmlDoc;
}

function xmlmultidsigtool_createSignedXMLDoc()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_createSignedXMLDoc():................Start.");
    var /* nsIDOMDocument */ signedXmlDoc = null;

    var tabboxElem = document.getElementById("xmldsigffext.form.multisig.tabbox");
    var tabpanelsElem = document.getElementById("xmldsigffext.form.multisig.tabpanels");

    var xmlDSigEditorElemList = tabpanelsElem.getElementsByTagName("XmlDocSigEditor");
    if (xmlDSigEditorElemList.length <= 0) {
    	alert("Input XML document does not contain any signature element.");
	return;
    }

    var isSignedXmlDoc = true;
    var signedXmlDoc = gXmlMultiSigDocParams.unsignedXmlDoc.cloneNode(true);
    for (var i = 0; i < xmlDSigEditorElemList.length; i++) {
    	var xmlDSigEditorElem = xmlDSigEditorElemList.item(i);

	var isSignedXmlDoc = xmlDSigEditorElem.isSignedXmlDoc;
	var signerSignedXmlDoc = xmlDSigEditorElem.inputXmlDoc;
	if (!isSignedXmlDoc) {
	    if (xmlDSigEditorElem.signedXmlDoc) {
	    	signerSignedXmlDoc = xmlDSigEditorElem.signedXmlDoc;
	    }
	}
    	var signerSigElemList = signerSignedXmlDoc.getElementsByTagName("ds:Signature");
	if (signerSigElemList.length <= 0) {
    	    signerSigElemList = unsignedXmlDoc.getElementsByTagName("Signature");
	}
	var signerSigElem = signerSigElemList.item(0);
    	// XmlMultiDSigUtil.dump("xmlmultidsigtool_createSignedXMLDoc(): signerSigElem[" + i + "]:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(signerSigElem) + "\n");
	signerSigElem = signedXmlDoc.importNode(signerSigElem, true);
	signedXmlDoc.documentElement.appendChild(signerSigElem);
	gXmlMultiSigDocParams.signerSignedXmlDocList.push(signerSignedXmlDoc);
    }
    // XmlMultiDSigUtil.dump("xmlmultidsigtool_createSignedXMLDoc(): signedXmlDoc:\n" + XmlMultiDSigUtil.mXmlSerializer.serializeToString(signedXmlDoc) + "\n");

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_createSignedXMLDoc():................Start.");
    return signedXmlDoc;
}

function xmlmultidsigtool_saveSignedXMLDocToFile()
{
    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_saveSignedXMLDocToFile():................Start.");

    var /* nsILocalFile */ inputXMLFile = gXmlDSigInputFilePickerElem.file;
    if (inputXMLFile == null) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_saveSignedXMLDocToFile(): No input XML file is selected.");
    	alert("xmlmultidsigtool_saveSignedXMLDocToFile(): No input XML file is selected.");
    	return null;
    }

    var /* nsILocalFile */ outSignedXMLFile = null;
    if (gXmlDSigSignedOutFilePickerElem.value == "") {
	xmlmultidsigtool_autoSelectOutSignedFile(inputXMLFile);
    }
    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (outSignedXMLFile == null) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_saveSignedXMLDocToFile(): failed to get outSignedXMLFile.");
    	alert("xmlmultidsigtool_saveSignedXMLDocToFile(): failed to get outSignedXMLFile.");
        return null;
    }
    XmlMultiDSigUtil.logDebug("xmlmultidsigtool_saveSignedXMLDocToFile(): outSignedXMLFile: " + outSignedXMLFile.path + "");

    // Create signed XML doc 
    var /* nsIDOMDocument */ signedXmlDoc = null;

    // TODO: Create a single Signed  XML doc with multiple signature from individually signed documents.

    signedXmlDoc = xmlmultidsigtool_createSignedXMLDoc();
    if (signedXmlDoc == null) {
	alert("Failed create aggregate signed XML document.");
    	return;
    }

    // Save signed XML doc 
    var signedXmlDocStr = XmlMultiDSigUtil.mXmlSerializer.serializeToString(signedXmlDoc);
    gXmlDSigSignedOutFilePickerElem.saveFile(signedXmlDocStr);
    gXmlDSigSignedOutFilePickerElem.refresh();

    outSignedXMLFile = gXmlDSigSignedOutFilePickerElem.file;
    if (!outSignedXMLFile || !outSignedXMLFile.exists() || (outSignedXMLFile.fileSize <= 0)) {
    	XmlMultiDSigUtil.logError("xmlmultidsigtool_saveSignedXMLDocToFile(): failed to create Signed XML file.");
    	// alert("xmlmultidsigtool_saveSignedXMLDocToFile(): failed to create Signed XML file.");
	return null;
    }

    gXmlDSigSignedOutDocVerifyElem.hidden = false;

    XmlMultiDSigUtil.logTrace("xmlmultidsigtool_saveSignedXMLDocToFile():................End.");

    return gXmlDSigSignedOutFilePickerElem.file;
}

function xmlmultidsigtool_loadAndVerifySignedDoc()
{
    var inputXmlDocPath = gXmlDSigSignedOutFilePickerElem.value;
    gXmlDSigSignedOutFilePickerElem.value = "";

    xmlmultidsigtool_setInputXMLFilePath(inputXmlDocPath);
}

